SystemOrganization addCategory: #Marea!
SystemOrganization addCategory: #'Marea-Swapping'!
SystemOrganization addCategory: #'Marea-Serializers'!
SystemOrganization addCategory: #'Marea-GraphTraverse'!

FLPrimitiveCluster subclass: #FLProxyCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Serializers'!

!FLProxyCluster class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 7/18/2011 12:04'!
id

	^102! !

!FLProxyCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 10/4/2011 15:32'!
add: anObject traceWith: anAnalyzer
	"Add an object to the cluster. We know the object doesn't have references."

	objects add: anObject! !

!FLProxyCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 10/3/2011 16:38'!
materializeFrom: aReadStream
	
	^ RegularObjectProxy newProxy mareaProxyID: (aReadStream int32)! !

!FLProxyCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 10/4/2011 15:31'!
newSerializingCollection
	"Answer a collection for the objects that correspond to this cluster."

	^ProxiesIdentitySet new! !

!FLProxyCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 10/4/2011 15:31'!
registerIndexesOn: aDictionary

	self flag: #todo. "Converting objects collection here in this method is a bit confusing. This is because since this cluster is for primitives, they do not have pointers to other objects. Hence, instead of storing them in a IdentitySet we can use an OrderedCollection and then just convert them at the end. For more details see FLPrimitiveCluster >> #add: anObject traceWith: anAnalyzer"
	self objects do: [ :instance | aDictionary at: instance put: aDictionary size + 1 ].! !

!FLProxyCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 10/3/2011 16:36'!
serialize: aProxy on: aWriteStream
	aWriteStream 
		int32: aProxy mareaProxyID ! !

!FLSerializer methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 10/4/2011 17:32'!
mareaSerialization

	^ serializationFactory := [:anObject :aStream | 
		(FLMareaSerialization 
			root: anObject 
			on: aStream
			analyzer: self analyzer)
			run;
			yourself ]! !

FLMapper subclass: #FLProxyMapper
	instanceVariableNames: 'mareaProxyCluster'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Serializers'!

!FLProxyMapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/3/2011 15:12'!
accepts: anObject

	^ anObject mareaIsProxy! !

!FLProxyMapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/3/2011 15:13'!
clusterFor: anObject

	^ mareaProxyCluster
! !

!FLProxyMapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/3/2011 15:53'!
initialize

	mareaProxyCluster := FLProxyCluster new.
! !

!SmallInteger methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 10/4/2011 15:40'!
mareaIdentityHash

	^self hashMultiply! !

!CompiledMethod class methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 12/1/2011 12:52'!
receiver: aReceirver withArgs: argArray executeMethod: compiledMethod
	"Execute compiledMethod against the receiver and args in argArray"

	<primitive: 188>
	self primitiveFailed! !

FLAnalyzer subclass: #FLMareaAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Serializers'!

!FLMareaAnalyzer methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/3/2011 16:10'!
mappers

	| mappers |
	mappers := OrderedCollection new.
	mappers add: FLProxyMapper new.
	mappers addAll: self pluggableSubstitutionMappers.
	mappers addAll: self globalMappers.
	mappers add: self defaultMapper.
	^mappers! !

FLMaterializer subclass: #FLMaterializerForSwapping
	instanceVariableNames: 'weakSerializedObjects rootProxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Serializers'!

!FLMaterializerForSwapping class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 8/6/2011 11:49'!
on: aReadStream serializedObjects: serializedObjects rootProxy: rootProxy

	^self new
		stream: aReadStream;
		weakSerializedObjects: serializedObjects ;
		rootProxy: rootProxy;
		yourself
! !

!FLMaterializerForSwapping methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 8/2/2011 11:05'!
addAllMaterialized: aCollection
	aCollection do: [:each | self addMaterialized: each].
! !

!FLMaterializerForSwapping methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 8/6/2011 11:58'!
addMaterialized: anObject
 	| serializedInstanceOrNil |

  	serializedInstanceOrNil := weakSerializedObjects at: (materializedInstances size + 1).
	
	(serializedInstanceOrNil == rootProxy) ifTrue: [
		"the root was becomed a proxy so I cannot send any message to it because otherwise it will try to materialize it, generating a loop. 
		In addition, if this is the proxy, I ALWAYS have to take the object serialized instead of the proxy."
		materializedInstances addLast: anObject.
		^ self].
	
	serializedInstanceOrNil mareaIsProxy ifTrue: [
		materializedInstances addLast: serializedInstanceOrNil .
		^ self.].   
	
	materializedInstances addLast: (  serializedInstanceOrNil isNil
            ifTrue: [anObject]         
		 " The GC collected that object, hence we kept the one we have serialized."
            ifFalse: [serializedInstanceOrNil]
	"The GC did not collected the object, so it was probably a shared obejct. So, we kept the instance already existing in the image")! !

!FLMaterializerForSwapping methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 8/2/2011 10:14'!
initialize 
	super initialize.
	weakSerializedObjects := WeakOrderedCollection new.! !

!FLMaterializerForSwapping methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 8/6/2011 11:53'!
rootProxy
	^ rootProxy! !

!FLMaterializerForSwapping methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 8/6/2011 11:53'!
rootProxy: anObject
	rootProxy := anObject! !

!FLMaterializerForSwapping methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 8/2/2011 10:06'!
weakSerializedObjects
	^ weakSerializedObjects! !

!FLMaterializerForSwapping methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 8/2/2011 10:06'!
weakSerializedObjects: anObject
	weakSerializedObjects := anObject! !

!ProtoObject methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 10/4/2011 15:17'!
mareaIdentityHash
	"Answer a SmallInteger whose value is related to the receiver's identity.
	This method must not be overridden, except by SmallInteger.
	
	Do not override."

	^ self basicIdentityHash bitShift: 18! !

AbstractClassProxySwapper subclass: #ClassProxy
	instanceVariableNames: 'proxyID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Swapping'!

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2011 16:03'!
mareaGraphID
	^ proxyID bitAnd: 2r111111111111111! !

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2011 16:03'!
mareaHandler
	^ RegularObjectProxyHandler ! !

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2011 16:03'!
mareaIsProxyInstalled
	^ proxyID isNil not! !

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2011 16:03'!
mareaPosition
	^ proxyID >> 15 
	! !

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2011 16:03'!
mareaProxyID
	^ proxyID! !

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2011 16:03'!
mareaProxyID: aNumber
	proxyID := aNumber! !

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2011 16:03'!
mareaSetPosition: aPosition setGraphID: aGraphID
	proxyID :=  (aGraphID bitAnd: 16rFFFF) bitOr: (aPosition << 15).
! !

FLSerialization subclass: #FLMareaSerialization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Swapping'!

!FLMareaSerialization methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/15/2011 22:32'!
analysisStep

	| anAnalysis |
	anAnalysis := analyzer analysisFor: root.
	clusters := anAnalysis clusterization clusters.
	objectCount := anAnalysis clusterization objectCount.
	objectsIndexes := ProxiesIdentityDictionary new: objectCount.
	indexCluster := FLSmallIntegerCluster for: objectCount.! !

FLSerialization subclass: #FLSerializerForSwapping
	instanceVariableNames: 'weakSerializedObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Serializers'!

!FLSerializerForSwapping methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 8/2/2011 14:40'!
initialize
	super initialize.
	weakSerializedObjects := WeakOrderedCollection new.! !

!FLSerializerForSwapping methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/27/2011 10:30'!
serializeCluster: aCluster objects: aCollection

	aCollection do: [ :instance | 
		objectsIndexes at: instance put: objectsIndexes size + 1.
		(instance == root) ifTrue: [ weakSerializedObjects addLast: nil ]
		ifFalse: [weakSerializedObjects addLast: instance].
		 ].
	self encodeIdOf: aCluster.
	aCluster serializeAll: aCollection with: self.
! !

!FLSerializerForSwapping methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 8/2/2011 11:18'!
weakSerializedObjects 
	^ weakSerializedObjects ! !

TestCase subclass: #GraphTraverserTest
	instanceVariableNames: 'serializedObjects stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-GraphTraverse'!

!GraphTraverserTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/16/2011 15:05'!
testCreateProxy
	| proxy |
	proxy := MareaProxyMock new mareaSetPosition: 7678 setGraphID: 3454.
	self assert: proxy mareaPosition equals: 7678.
	self assert: proxy mareaGraphID equals: 3454.

	proxy := MareaProxyMock new mareaSetPosition: 3223 setGraphID: 6754.
	self assert: proxy mareaPosition equals: 3223.
	self assert: proxy mareaGraphID equals: 6754.
	
	proxy := MareaProxyMock new mareaSetPosition: 0 setGraphID: 0.
	self assert: proxy mareaPosition equals: 0.
	self assert: proxy mareaGraphID equals: 0.
	
	proxy := MareaProxyMock new mareaSetPosition: 1 setGraphID: 5.
	self assert: proxy mareaPosition equals: 1.
	self assert: proxy mareaGraphID equals: 5.
	
	proxy := MareaProxyMock new mareaSetPosition: 255 setGraphID: 1024.
	self assert: proxy mareaPosition equals: 255.
	self assert: proxy mareaGraphID equals: 1024.
	
	proxy := MareaProxyMock new mareaSetPosition: 254 setGraphID: 1023.
	self assert: proxy mareaPosition equals: 254.
	self assert: proxy mareaGraphID equals: 1023.
	
	"Max values"
	proxy := MareaProxyMock new mareaSetPosition: 65535 setGraphID: 32767.
	self assert: proxy mareaPosition equals: 65535.
	self assert: proxy mareaGraphID equals: 32767.
	
	
	
! !

!GraphTraverserTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/13/2011 10:49'!
testCycle
	| a set |
	
	a := ClassWith2Var new.
	a var1: Date today.
	a var2: a.
	
	set := GraphTraverser traverse: a.
	self assert: set size equals: 9.! !

!GraphTraverserTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/19/2011 16:23'!
testGlobalSharedProxyTable
	| proxy table |
	
	table := Dictionary new. 
	proxy := MareaProxyMock new mareaSetPosition: 7678 setGraphID: 3454.
	table at: proxy mareaProxyID put: proxy.
	self assert: (table at: proxy mareaProxyID) mareaPosition equals: 7678.
	self assert: (table at: proxy mareaProxyID) mareaGraphID equals: 3454.
	
	table := Dictionary new. 
	proxy := MareaProxyMock new mareaSetPosition: 4 setGraphID: 1.
	table at: proxy mareaProxyID put: proxy.
	self assert: (table at: proxy mareaProxyID) mareaPosition equals: 4.
	self assert: (table at: proxy mareaProxyID) mareaGraphID equals: 1.
	
	table := Dictionary new. 
	proxy := MareaProxyMock new mareaSetPosition: 4 setGraphID: 2.
	table at: proxy mareaProxyID put: proxy.
	self assert: (table at: proxy mareaProxyID) mareaPosition equals: 4.
	self assert: (table at: proxy mareaProxyID) mareaGraphID equals: 2.! !

!GraphTraverserTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/13/2011 10:43'!
testNoCycle
	| a b set |
	
	a := ClassWith2Var new.
	b := ClassWith1Var new. 
	b var1: 'nose'.
	a var1: Date today.
	a var2: b.
	
	set := GraphTraverser traverse: a.
	self assert: set size equals: 15.! !

TestCase subclass: #ObjectGraphSwapperTest
	instanceVariableNames: 'proxyClass proxyCreatorClass classFactory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Swapping'!

ObjectGraphSwapperTest subclass: #ObjectGraphSwapperMockTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Swapping'!

ObjectGraphSwapperTest subclass: #ObjectGraphSwapperRealTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Swapping'!

!ObjectGraphSwapperRealTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/1/2011 16:05'!
setUp
	super setUp.
	proxyClass := RegularObjectProxy.
	proxyCreatorClass := RegularObjectProxy.
! !

!ObjectGraphSwapperRealTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2011 16:18'!
swapIn: anObject	
	anObject name.! !

!ObjectGraphSwapperRealTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2011 14:34'!
swapOut: anObject
		ObjectGraphSwapper new swapOutGraph: anObject.
! !

!ObjectGraphSwapperRealTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/1/2011 12:51'!
testSwapOutClassWithLiveGuiltyInstance

	| aClass aClassCopy instance |

	3 timesRepeat: [Smalltalk garbageCollect].

	aClass := self newClassWithInstanceVariableNames: 'foo'.
	aClass compileSilently: 'foo ^ foo'.
	aClass compileSilently: 'foo: aFoo 
					foo := aFoo'.
	instance := aClass new.
	instance perform: #foo: with: 42.
	aClassCopy	:= aClass veryDeepCopy.

	self swapOutClass: aClass.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: aClass mareaIsProxy. 
	
	instance name.	
	3 timesRepeat: [Smalltalk garbageCollect].

	self assert: (instance perform: #foo) = 42.
	self assert: instance class == aClass.
	self deny: aClass mareaIsProxy. 
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
	
! !

!ObjectGraphSwapperTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/30/2011 14:20'!
classFactory
	^classFactory! !

!ObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 11/30/2011 14:20'!
newClassOrTrait
	"Returns a class for testing"

	^ self newClassWithInstanceVariableNames: ''! !

!ObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 12/1/2011 17:28'!
newClassWithInstanceVariableNames: instanceVariableNames
	"Returns a class for testing, with the specified instance variables."
	
	"| m c metaformat format postFix |

	metaformat := ClassBuilder new
	    computeFormat: #normal instSize: 0
	    forSuper: Object class ccIndex: 0.
	
	format := ClassBuilder new
	    computeFormat: #normal instSize: instanceVariableNames size
	    forSuper: Object ccIndex: 0.

	m := Metaclass new.
	m superclass: Object class.
	m methodDict: MethodDictionary new.
	m setFormat: metaformat.

	c := m new.
	c superclass: Object.
	c methodDict: MethodDictionary new.
	c setFormat: format.

	c setInstVarNames: instanceVariableNames.
	postFix := (DateAndTime now asSeconds) printString.
	c setName: (#ClassForTestToBeDeleted, postFix) asSymbol.
	Smalltalk at: c name put: c."
	
	^ self classFactory
		newSubclassOf: Object
		instanceVariableNames: instanceVariableNames
		classVariableNames: ''! !

!ObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 10/3/2011 14:23'!
proxyClass
	^ proxyClass ! !

!ObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 10/3/2011 14:23'!
proxyCreatorClass
	^ proxyCreatorClass! !

!ObjectGraphSwapperTest methodsFor: 'setUp - tearDown' stamp: 'MarianoMartinezPeck 12/1/2011 17:53'!
setUp
	
	proxyClass := MareaProxyMock.
	proxyCreatorClass := MareaProxyMock.
	
	super setUp.
	self setUpClassFactory.
	
	MareaLogger changeToTranscriptLogger.

	
	ObjectGraphSwapper resetGlobalTable.
	ObjectGraphSwapper resetGraphID.
	ObjectGraphSwapper resetSharedProxiesTable.  
	ObjectGraphSwapper proxyCreator: self proxyCreatorClass.
	! !

!ObjectGraphSwapperTest methodsFor: 'setUp - tearDown' stamp: 'MarianoMartinezPeck 11/30/2011 14:20'!
setUpClassFactory
	classFactory := ClassFactoryForTestCase new! !

!ObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 11/30/2011 16:18'!
swapIn: anObject	
	ObjectGraphSwapper new swapInGraphFor: anObject.! !

!ObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 9/29/2011 14:18'!
swapOut: anObject
		ObjectGraphSwapper new swapOutGraph: anObject.
! !

!ObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 11/30/2011 14:48'!
swapOutClass: aClass
		ObjectGraphSwapper new swapOutClass: aClass.
! !

!ObjectGraphSwapperTest methodsFor: 'setUp - tearDown' stamp: 'MarianoMartinezPeck 12/1/2011 19:00'!
tearDown
	ObjectGraphSwapperTest compileAll.
	self classFactory cleanUp.
	Smalltalk allClasses do: [:each | each removeAllObsoleteSubclasses].
	! !

!ObjectGraphSwapperTest methodsFor: 'tests basic' stamp: 'MarianoMartinezPeck 9/29/2011 14:18'!
testAmountOfProxiesAndBecome
	"We test that we creat the right amount of proxies, that is, that after a GC runs, we should only have proxies for the root and the facade objects. In addition, we test we correctly did the become. "
	| a b proxiesCount |

	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self proxyClass instanceCount.

	a := ClassWith2Var new.
	b := ClassWith1Var new. 
	"Do not put a string or something like that because otherwise it is stored in the literals of the method and hence it is considered as a shared object"
	b var1: 6.
	a var1: (Point x: 4 y: 2).
	a var2: b.

	self swapOut: a.
	
	3 timesRepeat: [Smalltalk garbageCollect].
	"One proxy for the root A and one proxy for the shared object B."
	self assert: self proxyClass instanceCount equals: proxiesCount + 2.
	self assert: a mareaIsProxy.  
	self assert: b mareaIsProxy. 
! !

!ObjectGraphSwapperTest methodsFor: 'tests specials' stamp: 'MarianoMartinezPeck 9/29/2011 14:20'!
testAmountOfProxiesAndBecomeWithSpecialObjects
	"We test that we creat the right amount of proxies, that is, that after a GC runs, we should only have proxies for the root and the facade objects. In addition, we test we correctly did the become. We should NOT create proxies for nil, true or false and some other special objects "
	| a b proxiesCount c |

	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self proxyClass instanceCount.

	a := OrderedCollection new.
	b := Smalltalk. 
	c := Processor.
	"Do not put a string or something like that because otherwise it is stored in the literals of the method and hence it is considered as a shared object"
	a add: b.
	a add: c.

	self swapOut: a
	.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: self proxyClass instanceCount equals: proxiesCount + 1.
	self assert: a mareaIsProxy. 
	
	self swapIn: a.	
	3 timesRepeat: [Smalltalk garbageCollect].

	"One proxy for the root A and NONE proxy for the shared object B because it is nil."
	self assert: self proxyClass instanceCount equals: proxiesCount.
	self assert: a mareaClass = OrderedCollection. 
	self assert: b == Smalltalk. 
	self assert: b == a first.
	self assert: c == Processor.
	self assert: c == a second. 

	! !

!ObjectGraphSwapperTest methodsFor: 'tests specials' stamp: 'MarianoMartinezPeck 9/29/2011 14:22'!
testAmountOfProxiesAndBecomeWithTrueNilFalse
	"We test that we creat the right amount of proxies, that is, that after a GC runs, we should only have proxies for the root and the facade objects. In addition, we test we correctly did the become. We should NOT create proxies for nil, true or false. "
	| a b proxiesCount c d |

	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self proxyClass instanceCount.

	a := OrderedCollection new.
	b := nil. 
	c := true.
	d := false.
	"Do not put a string or something like that because otherwise it is stored in the literals of the method and hence it is considered as a shared object"
	a add: b.
	a add: c.
	a add: d.

	self swapOut: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: self proxyClass instanceCount equals: proxiesCount + 1.
	self assert: a mareaIsProxy. 
	
	self swapIn: a.	
	3 timesRepeat: [Smalltalk garbageCollect].

	"One proxy for the root A and NONE proxy for the shared object B because it is nil."
	self assert: self proxyClass instanceCount equals: proxiesCount.
	self assert: a class = OrderedCollection. 
	self assert: b isNil. 
	self assert: b == a first.
	self assert: c.
	self assert: c == a second. 
	self deny: d. 
	self assert: d == a third.
	
	! !

!ObjectGraphSwapperTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 12/1/2011 19:26'!
testClassAndMetaclassAreGarbageCollected

	| aClass metaclassesSize |

	[	
	10 timesRepeat: [Smalltalk garbageCollect].
	metaclassesSize := Metaclass instanceCount.

	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.

	10 timesRepeat: [Smalltalk garbageCollect].
	self assert: (metaclassesSize + 1) equals: Metaclass instanceCount.

	self swapOutClass: aClass.
	10 timesRepeat: [Smalltalk garbageCollect].
	self assert: aClass mareaIsProxy. 
	DebuggerMethodMap cleanUp.
	10 timesRepeat: [Smalltalk garbageCollect].
	"I comment this line because sometimes it works and sometimes it doesnt. However, if I close the test, run a garbage collect from outside, the instaces are garbage collected. So I think it is something related to the tests"
	"self assert: metaclassesSize equals: Metaclass instanceCount."
	
	self swapIn: aClass.	
	10 timesRepeat: [Smalltalk garbageCollect].
	self assert: (metaclassesSize + 1) equals: Metaclass instanceCount.
	
	 ] ensure: [ aClass mareaIsProxy ifTrue: [ self swapIn: aClass.  ] ]! !

!ObjectGraphSwapperTest methodsFor: 'tests basic' stamp: 'MarianoMartinezPeck 9/29/2011 14:24'!
testFacadeObjectNotAnymoreNoIntersection
	"This tests that a graph is loaded back when the ROOT receives a message and when there is NO intersection probem, that is, there is no swapping of external graphs that refer to our facade objects. In addition, it tests that a facade object to which we have created a proxy, is garbage collected because nobody else point to it. "
	| a b proxiesCount |
	
	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self proxyClass instanceCount.
	
	a := ClassWith2Var new.
	b := ClassWith1Var new. 
	"Do not put a string or something like that because otherwise it is stored in the literals of the method and hence it is considered as a shared object"
	b var1: 6.
	a var1: (Point x: 4 y: 2).
	a var2: b.

	self swapOut: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	
	"Now lets say that nobody else point to the facade object B"	
	self assert: self proxyClass instanceCount equals: proxiesCount + 2.
	b := nil.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: self proxyClass instanceCount equals: proxiesCount + 1.
	
	self swapIn: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: self proxyClass instanceCount equals: proxiesCount.
	self assert: a var2 var1 equals: 6.
	self assert: a var1 equals: 4@2.
	! !

!ObjectGraphSwapperTest methodsFor: 'tests intersection' stamp: 'MarianoMartinezPeck 9/29/2011 14:40'!
testIntersectionOutAOutCInAInC
	"This tests the following scenario: Both, object AAA and CCC, point to BBB. 
	- AAA is swapped out first.
	- CCC is swapped out.
	- AAA is swapped in.
	- CCC is swapped in"
	| a b proxiesCount c |
	
	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self proxyClass instanceCount.
	
	a := ClassWith1Var new.
	b := (Point x: 4 y: 2).
	c := ClassWith1Var new. 
	c var1: b.
	a var1: b.

	self assert: ObjectGraphSwapper globalSharedProxiesTable size equals: 0.
	self assert: ObjectGraphSwapper globalGraphTable size equals: 0.
	
	self swapOut: a.

	3 timesRepeat: [Smalltalk garbageCollect].
	
	self assert: ObjectGraphSwapper globalSharedProxiesTable size equals: 0.
	self assert: ObjectGraphSwapper globalGraphTable size equals: 1.
	self assert: (ObjectGraphSwapper globalGraphTable at: 1) size equals: 2.
		
	"There should be a proxy for A and B"	
	self assert: self proxyClass instanceCount equals: proxiesCount + 2.
	self assert: b mareaIsProxy.
	self assert: a mareaIsProxy.
		
	"Now we swap another graph, C, which has intersection with A"
	self swapOut: c.
	self assert: ObjectGraphSwapper globalSharedProxiesTable size equals: 1.
	self assert: ObjectGraphSwapper globalGraphTable size equals: 2.
	self assert: (ObjectGraphSwapper globalGraphTable at: 1) size equals: 2.
	self assert: (ObjectGraphSwapper globalGraphTable at: 2) size equals: 2.
		

	"We have to be sure that when finding a proxy in the graph to serialize, we do not uninstall it"	
	self assert: b mareaIsProxy.
	self assert: c mareaIsProxy.


	"Lets clean the pointers from the test"
	b := nil.
	3 timesRepeat: [Smalltalk garbageCollect].

	
	self swapIn: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: a var1 equals: (Point x: 4 y: 2).

	self swapIn: c.
	self deny: c mareaIsProxy.
	self deny: c var1 mareaIsProxy.
	self assert: c var1 == a var1.
	! !

!ObjectGraphSwapperTest methodsFor: 'tests intersection' stamp: 'MarianoMartinezPeck 9/29/2011 14:28'!
testIntersectionOutAOutCInCInA
	"This tests the following scenario: Both, object AAA and CCC, point to BBB. 
	- AAA is swapped out first.
	- CCC is swapped out.
	- CCC is swapped in
	- AAA is swapped in.
	It is important to notice in this case that when C is swapped in, B it is not. There will be a proxy there. B will only be replaced with the original object, only when the graph where it was serialized, is swapped in.
	"
	| a b proxiesCount c |
	
	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self proxyClass instanceCount.
	
	a := ClassWith1Var new.
	b := (Point x: 4 y: 2).
	c := ClassWith1Var new. 
	c var1: b.
	a var1: b.

	self assert: ObjectGraphSwapper globalSharedProxiesTable size equals: 0.
	self assert: ObjectGraphSwapper globalGraphTable size equals: 0.
	
	self swapOut: a.

	3 timesRepeat: [Smalltalk garbageCollect].
	
	self assert: ObjectGraphSwapper globalSharedProxiesTable size equals: 0.
	self assert: ObjectGraphSwapper globalGraphTable size equals: 1.
	self assert: (ObjectGraphSwapper globalGraphTable at: 1) size equals: 2.
		
	"There should be a proxy for A and B"	
	self assert: self proxyClass instanceCount equals: proxiesCount + 2.
	self assert: b mareaIsProxy.
	self assert: a mareaIsProxy.
		
	"Now we swap another graph, C, which has intersection with A"
	self swapOut: c.
	self assert: ObjectGraphSwapper globalSharedProxiesTable size equals: 1.
	self assert: ObjectGraphSwapper globalGraphTable size equals: 2.
	self assert: (ObjectGraphSwapper globalGraphTable at: 1) size equals: 2.
	self assert: (ObjectGraphSwapper globalGraphTable at: 2) size equals: 2.
		

	"We have to be sure that when finding a proxy in the graph to serialize, we do not uninstall it"	
	self assert: b mareaIsProxy.
	self assert: c mareaIsProxy.


	"Lets clean the pointers from the test"
	b := nil.
	3 timesRepeat: [Smalltalk garbageCollect].

	self swapIn: c.
	self deny: c mareaIsProxy.
	self assert: c var1 mareaIsProxy.

	self swapIn: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: a var1 equals: (Point x: 4 y: 2).
	self deny: c var1 mareaIsProxy.
	self assert: c var1 == a var1.
! !

!ObjectGraphSwapperTest methodsFor: 'tests intersection' stamp: 'MarianoMartinezPeck 9/29/2011 14:29'!
testIntersectionOutAOutCInCInB
	"This tests the following scenario: Both, object AAA and CCC, point to BBB. 
	- AAA is swapped out first.
	- CCC is swapped out.
	- CCC is swapped in.
	- BBB is swapped in
	It is important to notice in this case that when C is swapped in, B it is not. There will be a proxy there. B will only be replaced with the original object, only when the graph where it was serialized, is swapped in.
	"
	| a b proxiesCount c |
	
	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self proxyClass instanceCount.
	
	a := ClassWith1Var new.
	b := (Point x: 4 y: 2).
	c := ClassWith1Var new. 
	c var1: b.
	a var1: b.

	self assert: ObjectGraphSwapper globalSharedProxiesTable size equals: 0.
	self assert: ObjectGraphSwapper globalGraphTable size equals: 0.
	
	self swapOut: a.

	3 timesRepeat: [Smalltalk garbageCollect].
	
	self assert: ObjectGraphSwapper globalSharedProxiesTable size equals: 0.
	self assert: ObjectGraphSwapper globalGraphTable size equals: 1.
	self assert: (ObjectGraphSwapper globalGraphTable at: 1) size equals: 2.
		
	"There should be a proxy for A and B"	
	self assert: self proxyClass instanceCount equals: proxiesCount + 2.
	self assert: b mareaIsProxy.
	self assert: a mareaIsProxy.
		
	"Now we swap another graph, C, which has intersection with A"
	self swapOut: c.
	self assert: ObjectGraphSwapper globalSharedProxiesTable size equals: 1.
	self assert: ObjectGraphSwapper globalGraphTable size equals: 2.
	self assert: (ObjectGraphSwapper globalGraphTable at: 1) size equals: 2.
	self assert: (ObjectGraphSwapper globalGraphTable at: 2) size equals: 2.
		

	"We have to be sure that when finding a proxy in the graph to serialize, we do not uninstall it"	
	self assert: b mareaIsProxy.
	self assert: c mareaIsProxy.


	"Lets clean the pointers from the test"
	b := nil.
	3 timesRepeat: [Smalltalk garbageCollect].

	self swapIn: c.
	self deny: c mareaIsProxy.
	self assert: c var1 mareaIsProxy.

	self swapIn: c var1.
	3 timesRepeat: [Smalltalk garbageCollect].
	self deny: c var1 mareaIsProxy.
	self assert: a var1 equals: (Point x: 4 y: 2).
	self assert: c var1 == a var1.
	! !

!ObjectGraphSwapperTest methodsFor: 'tests basic' stamp: 'MarianoMartinezPeck 9/29/2011 14:30'!
testRootObjectNotAnymoreNoIntersection
	"This tests that a graph is loaded back when a facade object receives a message and when there is NO intersection probem, that is, there is no swapping of external graphs that refer to our facade objects. In addition, it tests that the root object to which we have created a proxy, is garbage collected because nobody else point to it. "
	| a b proxiesCount |
	
	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self proxyClass instanceCount.
	
	a := ClassWith2Var new.
	b := ClassWith1Var new. 
	"Do not put a string or something like that because otherwise it is stored in the literals of the method and hence it is considered as a shared object"
	b var1: 6.
	a var1: (Point x: 4 y: 2).
	a var2: b.

	self swapOut: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	
	"Now lets say that nobody else point to the root object A"	
	self assert: self proxyClass instanceCount equals: proxiesCount + 2.
	a := nil.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: self proxyClass instanceCount equals: proxiesCount + 1.
	
	self swapIn: b.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: self proxyClass instanceCount equals: proxiesCount.
	self assert: b var1 equals: 6.
! !

!ObjectGraphSwapperTest methodsFor: 'tests pending' stamp: 'MarianoMartinezPeck 9/15/2011 12:17'!
testSomethingOptimizedByFuel! !

!ObjectGraphSwapperTest methodsFor: 'tests pending' stamp: 'MarianoMartinezPeck 9/15/2011 10:48'!
testSomethingWithNilsInside! !

!ObjectGraphSwapperTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 12/1/2011 12:20'!
testSwapOutClass

	| aClass aClassCopy |

	3 timesRepeat: [Smalltalk garbageCollect].

	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClassCopy	:= aClass veryDeepCopy.

	self swapOutClass: aClass.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: aClass mareaIsProxy. 
	
	self swapIn: aClass.	
	3 timesRepeat: [Smalltalk garbageCollect].

	self deny: aClass mareaIsProxy. 
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
! !

!ObjectGraphSwapperTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 12/1/2011 16:29'!
testSwapOutClassAndTestMetaclassIsProxified
	| aClass aClassCopy aClassClassCopy metaclass |

	3 timesRepeat: [Smalltalk garbageCollect].

	aClass := self newClassOrTrait.
	aClass class compileSilently: 'foo ^ 42'.
	aClassClassCopy := aClass class veryDeepCopy.
	metaclass := aClass class. 

	self swapOutClass: aClass.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: aClass mareaIsProxy. 
	self assert: metaclass mareaIsProxy. 
	
	self swapIn: aClass.	
	3 timesRepeat: [Smalltalk garbageCollect].

	self deny: aClass mareaIsProxy. 
	self deny: aClass class mareaIsProxy. 

	self assert: aClass class name equals: aClassClassCopy name.
	self assert: aClass class methodDict equals: aClassClassCopy methodDict.
	self assert: aClass class subclasses equals: aClassClassCopy subclasses.
	self assert: aClass class format equals: aClassClassCopy format.! !

!ObjectGraphSwapperTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 12/1/2011 12:23'!
testSwapOutClassWithLiveInstance

	| aClass aClassCopy instance |

	3 timesRepeat: [Smalltalk garbageCollect].

	aClass := self newClassWithInstanceVariableNames: 'foo'.
	aClass compileSilently: 'foo ^ foo'.
	aClass compileSilently: 'foo: aFoo 
					foo := aFoo'.
	instance := aClass new.
	instance perform: #foo: with: 42.
	aClassCopy	:= aClass veryDeepCopy.

	self swapOutClass: aClass.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: aClass mareaIsProxy. 
	
	self swapIn: aClass.	
	3 timesRepeat: [Smalltalk garbageCollect].

	self deny: aClass mareaIsProxy. 
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
	self assert: instance class == aClass.
	self assert: (instance perform: #foo) = 42.
! !

!ObjectGraphSwapperTest methodsFor: 'tests basic' stamp: 'MarianoMartinezPeck 9/29/2011 14:31'!
testUninstallFromRootNoIntersection
	"This tests that a graph is loaded back when the ROOT receives a message and when there is NO intersection probem, that is, there is no swapping of external graphs that refer to our facade objects."
	| a b proxiesCount |
	
	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self proxyClass instanceCount.
	
	a := ClassWith2Var new.
	b := ClassWith1Var new. 
	"Do not put a string or something like that because otherwise it is stored in the literals of the method and hence it is considered as a shared object"
	b var1: 6.
	a var1: (Point x: 4 y: 2).
	a var2: b.
	
	self swapOut: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	self swapIn: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: self proxyClass instanceCount equals: proxiesCount.
	self assert: b == a var2.
	self assert: b var1 equals: 6.
	self assert: a var1 equals: 4@2.
	! !

!ObjectGraphSwapperTest methodsFor: 'tests basic' stamp: 'MarianoMartinezPeck 9/29/2011 14:31'!
testUninstallFromSharedObjectNoIntersection
	"This tests that a graph is loaded back when a facade object receives a message and when there is NO intersection probem, that is, there is no swapping of external graphs that refer to our facade objects."
	| a b proxiesCount |
	
	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self proxyClass instanceCount.
	
	a := ClassWith2Var new.
	b := ClassWith1Var new. 
	"Do not put a string or something like that because otherwise it is stored in the literals of the method and hence it is considered as a shared object"
	b var1: 6.
	a var1: (Point x: 4 y: 2).
	a var2: b.

	self swapOut: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	self swapIn: b.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: self proxyClass instanceCount equals: proxiesCount.
	self assert: b == a var2.
	self assert: b var1 equals: 6.
	self assert: a var1 equals: 4@2.! !

!ObjectGraphSwapperTest methodsFor: 'tests pending' stamp: 'MarianoMartinezPeck 9/14/2011 21:09'!
xtestRootObjectNotAnymoreNoIntersection2
	"This tests that a graph is loaded back when a facade object receives a message and when there is NO intersection probem, that is, there is no swapping of external graphs that refer to our facade objects. In addition, it tests that the root object to which we have created a proxy, is garbage collected because nobody else point to it. "
	| a b proxiesCount |
	
	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := MareaProxyMock instanceCount.
	
	a := ClassWith2Var new.
	b := ClassWith1Var new. 
	b var1: 'nose'.
	a var1: Date today.
	a var2: b.

	ObjectGraphSwapper new swapOutGraph: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	
	"Now lets say that nobody else point to the root object A"	
	self assert: MareaProxyMock instanceCount equals: proxiesCount + 2.
	a := nil.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: MareaProxyMock instanceCount equals: proxiesCount + 1.
	
	ObjectGraphSwapper new swapInGraphFor: b.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: MareaProxyMock instanceCount equals: proxiesCount.
	self assert: b var1 equals: 'nose'.
! !

AbstractObjectProxySwapper subclass: #RegularObjectProxy
	instanceVariableNames: 'proxyID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Swapping'!

!RegularObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/2/2011 15:10'!
mareaGraphID
	^ proxyID bitAnd: 2r111111111111111! !

!RegularObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/4/2011 17:24'!
mareaHandler
	^ RegularObjectProxyHandler ! !

!RegularObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/3/2011 10:05'!
mareaIsProxyInstalled
	^ proxyID isNil not! !

!RegularObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/2/2011 15:10'!
mareaPosition
	^ proxyID >> 15 
	! !

!RegularObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/2/2011 15:10'!
mareaProxyID
	^ proxyID! !

!RegularObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/3/2011 16:38'!
mareaProxyID: aNumber
	proxyID := aNumber! !

!RegularObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/2/2011 15:09'!
mareaSetPosition: aPosition setGraphID: aGraphID
	proxyID :=  (aGraphID bitAnd: 16rFFFF) bitOr: (aPosition << 15).
! !

IdentitySet subclass: #ProxiesIdentitySet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Swapping'!

!ProxiesIdentitySet methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/4/2011 15:23'!
asProxiesIdentitySet
	^self! !

!ProxiesIdentitySet methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/4/2011 15:23'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."

	| index start hash |
	hash := anObject mareaIdentityHash.
	index := start := hash \\ array size + 1.
	[ 
		| element |
		((element := array at: index) == nil or: [ element enclosedSetElement == anObject ])
			ifTrue: [ ^index ].
		(index := index \\ array size + 1) = start ] whileFalse.
	self errorNoFreeSpace! !

!ProxiesIdentitySet methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/4/2011 15:24'!
scanForEmptySlotFor: aKey
	"Scan the key array for the first slot containing an empty slot (indicated by a nil). Answer the index of that slot. This method will be overridden in various subclasses that have different interpretations for matching elements."
	
	| index start |
	index := start := aKey mareaIdentityHash \\ array size + 1.
	[ 
		(array at: index) ifNil: [ ^index ].
		(index := index \\ array size + 1) = start ] whileFalse.
	self errorNoFreeSpace! !

ObjectProxyHandler subclass: #RegularObjectProxyHandler
	instanceVariableNames: ''
	classVariableNames: 'MareaSerializer'
	poolDictionaries: ''
	category: 'Marea-Swapping'!

RegularObjectProxyHandler class
	instanceVariableNames: 'methodsNotToIntercept'!

RegularObjectProxyHandler class
	instanceVariableNames: 'methodsNotToIntercept'!

!RegularObjectProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 10/3/2011 14:55'!
debuggingMessagesToHandle
	| dict |
	dict := Dictionary new.
	dict at: #basicInspect put:#handleBasicInspect:.
	dict at: #inspect put:#handleInspect:.
	dict at: #inspectorClass put:#handleInspectorClass:.
	dict at: #defaultLabelForInspector put:#handleDefaultLabelForInspector:.
	dict at: #printStringLimitedTo: put: #handlePrintStringLimitedTo:.
	dict at: #printString put: #handlePrintString:.
	dict at: #longPrintOn:limitedTo:indent: put: #handleLongPrintOnLimitedToIndent:.
	dict at: #printOn: put: #handlePrintOn:.
	^ dict		! !

!RegularObjectProxyHandler class methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 10/2/2011 21:24'!
defaultMethodsNotToIntercept
	| dict |
	dict := Dictionary new.	
	dict addAll: self debuggingMessagesToHandle.
"	dict addAll: self methodsMessagesToHandle.
	dict addAll: self testSupportMessagesToHandle.
	dict addAll: self classProxyMessagesToHandle."
	^ dict
	
	! !

!RegularObjectProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 10/2/2011 21:23'!
handleBasicInspect: anInterception
	"Create and schedule an Inspector in which the user can examine the 
	receiver's variables. This method should not be overriden."
	^ToolSet basicInspect: anInterception proxy! !

!RegularObjectProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 10/2/2011 21:23'!
handleDefaultLabelForInspector: anInterception
	^ 'Proxy'! !

!RegularObjectProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 10/2/2011 21:23'!
handleInspect: anInterception
	"Create and schedule an Inspector in which the user can examine the receiver's variables."
	ToolSet inspect: anInterception proxy! !

!RegularObjectProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 10/2/2011 21:23'!
handleInspectorClass: anInterception
	"Answer the class of the inspector to be used on the receiver.  Called by inspect; 
	use basicInspect to get a normal (less useful) type of inspector."

	^ Inspector! !

!RegularObjectProxyHandler class methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 10/2/2011 15:22'!
handleInterception: aMessage for: aProxy
	| answer oldObject interception |
	self mareaLog: 'cannotInterpret: ', aMessage selector.
	
	interception := Interception for: aMessage target: nil proxy: aProxy receiver: nil. 
	(self isMessageNotToIntercept: aMessage)
		ifTrue: [ ^ self manageMessageInternally: interception ]
	 	ifFalse: [ ^ self manageMessage: interception  ]
	
	
	"oldObject := self uninstallForProxy: aProxy.
	self mareaLog: 'The message will be sent to the original object'.
	answer := aMessage sendTo: oldObject.
	self mareaLog: 'The message: ', aMessage selector asString, ' was sent to the original object'.
	^ answer "
! !

!RegularObjectProxyHandler class methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 12/1/2011 12:50'!
handleInterception: aMessage for: aProxy receiver: aReceiver

	| targetClass |
	self mareaLog: 'cannotInterpret: ', aMessage selector.
	targetClass := ObjectGraphSwapper new swapInGraphFor: aProxy.
	^ CompiledMethod receiver: aReceiver withArgs: aMessage arguments  executeMethod:  (targetClass lookupSelector: aMessage selector) 
	! !

!RegularObjectProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 10/2/2011 21:23'!
handleLongPrintOnLimitedToIndent: anInterception
	! !

!RegularObjectProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 10/2/2011 21:23'!
handlePrintOn: anInterception
	anInterception message arguments first nextPutAll: 'aProxy'  ! !

!RegularObjectProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 10/2/2011 21:24'!
handlePrintString: anInterception
	^ anInterception proxy printStringLimitedTo: 50000! !

!RegularObjectProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 10/2/2011 21:24'!
handlePrintStringLimitedTo: anInterception
	^ 'This is the print of a proxy'! !

!RegularObjectProxyHandler class methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 10/2/2011 15:23'!
isMessageNotToIntercept: aMessage
	^ self methodsNotToIntercept includesKey: aMessage selector  ! !

!RegularObjectProxyHandler class methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 10/3/2011 14:48'!
manageMessage: interception
	| target |
	self mareaLog: 'The method ', interception message selector, ' will beforwarded'.
"	self mareaLog: 'messa:', interception message asString.
	self mareaLog: 'target: :', interception target.
"	 
	target := ObjectGraphSwapper new swapInGraphFor: interception proxy.
	
	^ interception message sendTo: target
	! !

!RegularObjectProxyHandler class methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 10/3/2011 10:31'!
manageMessageInternally: anInterception 
	self mareaLog: 'The method ', anInterception message selector, ' will NOT be forwarded by instead answer by the handler'.
	^ self perform: (self methodsNotToIntercept at: anInterception message selector) with: anInterception ! !

!RegularObjectProxyHandler class methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 10/2/2011 15:23'!
methodsNotToIntercept
	methodsNotToIntercept isNil ifTrue: [ methodsNotToIntercept := self defaultMethodsNotToIntercept ].
	^ methodsNotToIntercept ! !

!RegularObjectProxyHandler class methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 10/2/2011 15:05'!
uninstallForProxy: aProxy
	^ self uninstallForProxy: aProxy ifNotInstalled: [ ProxyIsNotInstalled signal: 'The proxy is not installed. '].! !

!RegularObjectProxyHandler class methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 10/2/2011 15:07'!
uninstallForProxy: aProxy ifNotInstalled: errorBLock
	| oldObject originalObject |
	
	self mareaLog: 'Starting to uninstall.'.
	aProxy mareaIsProxyInstalled ifFalse: [ 
		self mareaLog: 'The proxy is not installed'.
		errorBLock value ].
	
	ObjectGraphSwapper new swapInGraphFor: aProxy.
	
	"now oldObject points to the proxy and aProxy points to the old object"
	self mareaLog: 'The Proxy for ', aProxy mareaBasicName, ' was uninstalled.'.
	^ aProxy.  
! !

!RegularObjectProxyHandler methodsFor: 'seeClassSide' stamp: 'MarianoMartinezPeck 10/2/2011 14:54'!
seeClassSide! !

IdentityDictionary subclass: #ProxiesIdentityDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Swapping'!

!ProxiesIdentityDictionary methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/4/2011 14:59'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	| finish start element |
	finish := array size.
	start := (anObject mareaIdentityHash \\ finish) + 1.

	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element := array at: index) == nil or: [element key == anObject])
			ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element := array at: index) == nil or: [element key == anObject])
			ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !

!ProxiesIdentityDictionary methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/4/2011 14:59'!
scanForEmptySlotFor: aKey
	"Scan the key array for the first slot containing an empty slot (indicated by a nil). Answer the index of that slot. This method will be overridden in various subclasses that have different interpretations for matching elements."
	
	| index start |
	index := start := aKey mareaIdentityHash \\ array size + 1.
	[ 
		(array at: index) ifNil: [ ^index ].
		(index := index \\ array size + 1) = start ] whileFalse.
	self errorNoFreeSpace! !

Object subclass: #AbstractMareaSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Serializers'!

!AbstractMareaSerializer methodsFor: 'API' stamp: 'MarianoMartinezPeck 4/1/2011 16:11'!
serializeAndWriteObject: anObject to: aFileName
	self shouldBeImplemented ! !

!AbstractMareaSerializer methodsFor: 'API' stamp: 'MarianoMartinezPeck 4/1/2011 16:11'!
unserializeObjectFrom: aFileName
	self shouldBeImplemented ! !

AbstractMareaSerializer subclass: #FuelMareaSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Serializers'!

FuelMareaSerializer subclass: #FuelCachedMareaSerializer
	instanceVariableNames: 'cachedAnalyzer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Serializers'!

!FuelCachedMareaSerializer class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2011 12:09'!
newDefault
	^ self new cachedAnalyzer: FLMareaAnalyzer newDefault! !

!FuelCachedMareaSerializer methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 7/6/2011 11:48'!
cachedAnalyzer
	^ cachedAnalyzer! !

!FuelCachedMareaSerializer methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 7/6/2011 11:48'!
cachedAnalyzer: anObject
	cachedAnalyzer := anObject! !

!FuelCachedMareaSerializer methodsFor: 'reset' stamp: 'MarianoMartinezPeck 11/30/2011 14:17'!
resetedCachedAnalyzer
	^ self cachedAnalyzer reset
	! !

!FuelCachedMareaSerializer methodsFor: 'reset' stamp: 'MarianoMartinezPeck 7/6/2011 14:48'!
resetedCachedAnalyzerWithInternalObjects: aCollection
	^ self cachedAnalyzer resetWithInternalObjects: aCollection
	! !

!FuelCachedMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 7/12/2011 13:31'!
serializeAndWriteClass: aClass to: aFileName
| serializer aFileStream |
      aFileStream := (StandardFileStream fileNamed: aFileName) binary.
      serializer := FLSerializer on: aFileStream.
	serializer 
		serialize: aClass 
		analyzer: (self resetedCachedAnalyzerWithInternalObjects: (Array with: aClass)).
      aFileStream close.
      self mareaLog: 'The class ', aClass name, ' was written on file'.! !

!FuelCachedMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 11/30/2011 12:07'!
serializeAndWriteObject: anObject to: aFileName
	| serialization aFileStream serializer proxyMapper | 
	aFileStream := (StandardFileStream fileNamed: aFileName) binary.
	serializer := FLSerializer newDefault analyzer: self resetedCachedAnalyzer.
	serializer mareaSerialization.
	serialization := serializer serialize: anObject on: aFileStream.
	aFileStream close.
	self mareaLog: 'The object ', anObject mareaBasicName, ' was written on file'.
	^ serialization! !

!FuelMareaSerializer class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 11/30/2011 14:22'!
newDefault
	^ self new! !

!FuelMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 8/3/2011 17:01'!
serializeAndWriteClass: aClass to: aFileName
| serializer aFileStream |
      aFileStream := (StandardFileStream fileNamed: aFileName) binary.
      serializer := FLSerializerForSwapping on: aFileStream.
      serializer
               serialize: aClass
               analyzer: (FLAnalyzer newDefaultInternalObjects: (Array with: aClass)).
      aFileStream close.
      self mareaLog: 'The class ', aClass name, ' was written on file'.
	^ serializer weakSerializedObjects ! !

!FuelMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 11/30/2011 14:51'!
serializeAndWriteObject: anObject to: aFileName
	| serialization aFileStream serializer proxyMapper analyzer | 
	aFileStream := (StandardFileStream forceNewFileNamed: aFileName) binary.
	analyzer := FLMareaAnalyzer newDefault. 
	anObject isBehavior
		ifTrue: [ analyzer considerInternalAll: (Array with: anObject)].
	serializer := FLSerializer newDefault analyzer: analyzer.
	serializer mareaSerialization.
	serialization := serializer serialize: anObject on: aFileStream.
	aFileStream close.
	self mareaLog: 'The object ', anObject mareaBasicName, ' was written on file'.
	^ serialization! !

!FuelMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 4/1/2011 16:11'!
unserializeObjectFrom: aFileName
	| materializer aFileStream |
	aFileStream := (StandardFileStream fileNamed: aFileName) binary.
	materializer := FLMaterializer on: aFileStream.
	materializer materialize.
	aFileStream close.
	^ materializer root
! !

!FuelMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 8/6/2011 11:50'!
unserializeObjectFrom: aFileName  serializedObjects:  serializedObjects rootProxy: rootProxy
	
	| materializer aFileStream |
	aFileStream := (StandardFileStream fileNamed: aFileName) binary.
	materializer := FLMaterializerForSwapping on: aFileStream serializedObjects: serializedObjects rootProxy: rootProxy.
	materializer materialize.
	aFileStream close.
	^ materializer root
! !

Object subclass: #CompiledMethodSwapper
	instanceVariableNames: ''
	classVariableNames: 'Logger ProxyClass'
	poolDictionaries: ''
	category: 'Marea-Swapping'!

!CompiledMethodSwapper class methodsFor: 'stuff to exclude' stamp: 'MarianoMartinezPeck 5/3/2011 17:44'!
classesNotToSwap

	| tooDangerousClasses coreClasses protoObjectSubclasses classesSpecialArray veryUsedClasses allClasses debuggingClasses nilSubclasses |

	"This are classes that are known as too dangerous."
	tooDangerousClasses := OrderedCollection new.
	(ClassBuilder new tooDangerousClasses) 
		do: [:each | Smalltalk globals at: each 
			ifPresent: [:present | tooDangerousClasses add: (Smalltalk at: each) ] 
			ifAbsent: []].
	
	"These classes because they are too core and used by the code to swapout itseld"
	coreClasses :=  {Array. Object. ProtoObject. Class. Message. MethodDictionary. CompiledMethod}. 

	"Subclasses of ProtoObject because they do not implement some methods that Object does and that are used by the swapping stuff."
	protoObjectSubclasses := ProtoObject subclasses.
	
	"These classes cannot be swapped because they are used by the VM"
	classesSpecialArray := Smalltalk specialObjectsArray select: [ :each | each isBehavior ].
	
	"These classes cannot be swapped because they install the segment (they are used) even before the segment can be written into a file"
	veryUsedClasses := { Cursor. CursorWithMask. EncodedCharSet.}.
	
	"Classes that are usually needed to debug and they help us to analyze problems"
	debuggingClasses := { DEVToolSet. }.
	
	"nil subclasses cannot be swapped out because since they don't subclass ProtoObject they may not even implement doesNotUnderstand:.
	For example, if we swap a CompiledMethod of PseudoContext, and then we try to load it back, the VM will crash with the error Recursive not understood error encountered. '"
	nilSubclasses := nil subclasses.
	
	allClasses := coreClasses, protoObjectSubclasses, classesSpecialArray, veryUsedClasses, tooDangerousClasses, debuggingClasses, nilSubclasses.
	
	^ allClasses asOrderedCollection ! !

!CompiledMethodSwapper class methodsFor: 'stuff to include' stamp: 'MarianoMartinezPeck 5/13/2011 10:28'!
compiledMethodsToSwap
	|  methodsToSwap classesNotToSwap packagesNotToSwap fixedMethodsNotToSwap |
	
	fixedMethodsNotToSwap := self fixedMethodsNotToSwap.
	
	UnusedObjectDiscoverer current startDiscovery. 

	self discoverMinimalUsedCompiledMethods.
	self methodsUsedByMareaTesting.
	
	packagesNotToSwap := self packagesNotToSwap.
	
	classesNotToSwap := self classesNotToSwap.
	packagesNotToSwap do: [:aPackage | classesNotToSwap addAll: aPackage classes ].
	packagesNotToSwap do: [:aPackage | fixedMethodsNotToSwap addAll: aPackage extensionMethods ].
	
	fixedMethodsNotToSwap do: [:aMethod | 	UnusedObjectDiscoverer current primitiveSetUsedBit: aMethod boolean: true].
	
	classesNotToSwap do: [:aClass | aClass markAllInstanceAndClassMethodsAsUsed].
	
	UnusedObjectDiscoverer current stopDiscovery.
	
	methodsToSwap := CompiledMethod unusedInstances.
	methodsToSwap := methodsToSwap reject: [:each | each isInstalled not ].
	
	Transcript show: 'Methods to swap: ',  methodsToSwap size asString; cr.
	Transcript show: 'Methods NOT to swap: ',  CompiledMethod usedInstances size asString; cr.
	
	^ methodsToSwap


! !

!CompiledMethodSwapper class methodsFor: 'stuff to exclude' stamp: 'MarianoMartinezPeck 11/27/2010 17:05'!
discoverMinimalUsedCompiledMethods
"These the minimal CompiledMethods needed to install and install a CompiledMethodProxy"
	| aProxy |
	
	SystemNavigation default browseClass: Object.
	
	aProxy := self installOn: ClassWith1Var selector: #foo.
	(ClassWith1Var methodDict at: #foo) literals.
	
	aProxy := self installOn: ClassWith1Var selector: #foo.
	ClassWith1Var new foo.! !

!CompiledMethodSwapper class methodsFor: 'examples' stamp: 'MarianoMartinezPeck 7/6/2011 11:39'!
exampleSwapOutAllUnusedMethods 
	"self exampleSwapOutAllUnusedMethods"
	| methodsToSwap timeToInstall timeToUninstall counter |
	"CompiledMethodProxyHandler mareaSerializer: FuelMareaSerializer. "
	CompiledMethodProxySwapperHandler serializer: FuelMareaSerializer new. 
	self proxyClass: NumberAsFilenameCompiledMethodProxySwapper.
	self proxyClass runningTest: false.
	self proxyClass mareaResetNumber.
	Logger := nil.
	"MareaLogger changeToFileLogger."
	MareaLogger disableLogging.
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Using proxy class: ', self proxyClass name.
	self log: 'Proxies installed instances before start: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances before start: ', CompiledMethod instanceCount asString.
	self log: 'Memory used before proxies: ', (Smalltalk vmParameterAt: 3) asString.
	"self printSpaceTally.
"	methodsToSwap := self compiledMethodsToSwap.
	self proxyClass: NumberAsFilenameCompiledMethodProxySwapper.
	self proxyClass runningTest: false.
	
	
	CompiledMethodProxySwapperHandler serializer: FuelMareaSerializer. 
	self log: 'CompiledMethods to swap: ',  methodsToSwap size asString.
	
	counter := 0.
	"[timeToInstall := MessageTally time: ["
	methodsToSwap do: [:method| 
		"(counter \\ 5000) isZero ifTrue: [
			self log: ''."
			"self log: SmalltalkImage current vmStatisticsReportString."
			"self log: ''."
		"]. 
		counter := counter + 1."
		"self log: 'Class: ', method methodClass name asString, ' selector: ', method selector asString. "
		self installOn: method methodClass selector: method selector.].
	"]."

	self log: 'Time to install proxies: ', timeToInstall asString, ' miliseconds'.
	methodsToSwap := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies intalled: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances after installing: ', CompiledMethod instanceCount asString.
	self log: 'Memory used using proxies: ', (Smalltalk vmParameterAt: 3) asString.

	[
"	timeToUninstall := MessageTally time: [
		counter := 0.
		self proxyClass mareaAllInstalledProxies do: [:instance| 
			(counter \\ 5000) isZero ifTrue: [
				self log: ''.
				self log: SmalltalkImage current vmStatisticsReportString.
				self log: ''.
				self printSpaceTally.
			]. 
		counter := counter + 1.
		instance mareaUninstallIfNeeded
		].		
	]."

	"self proxyClass mareaUninstallIfNeededAllInstances."
	self log: 'Time to uninstall proxies: ', timeToUninstall asString, ' miliseconds'.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies installed instances after uninstalling: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Memory used after uninstalling proxies: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'CompiledMethod instances after uninstalling: ', CompiledMethod instanceCount asString.
	"self printSpaceTally."
	] ensure: [
		self log: 'Ensure....'.
		"self proxyClass mareaUninstallIfNeededAllInstances."
"		(FileDirectory default fileNamesMatching: '*.swap*') 
			do: [ :aFile | FileDirectory default deleteFileNamed: aFile ]."
	]! !

!CompiledMethodSwapper class methodsFor: 'examples' stamp: 'MarianoMartinezPeck 7/6/2011 11:39'!
exampleSwapOutAllUnusedMethodsAndClasses
	"self nose"
	| methodsToSwap timeToInstall timeToUninstall counter |
	"CompiledMethodProxyHandler mareaSerializer: FuelMareaSerializer. "
	CompiledMethodProxySwapperHandler serializer: FuelMareaSerializer new. 
	self proxyClass: NumberAsFilenameCompiledMethodProxySwapper.
	self proxyClass runningTest: false.
	self proxyClass mareaResetNumber.
	Logger := nil.
	MareaLogger disableLogging.
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Using proxy class: ', self proxyClass name.
	self log: 'Methods Proxies installed instances before start: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Class Proxies installed instances before start: ', ClassProxySwapper mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances before start: ', CompiledMethod instanceCount asString.
	self log: 'Classes instances before start: ', Smalltalk allClassesAndTraits size asString.
	self log: 'Memory used before proxies: ', (Smalltalk vmParameterAt: 3) asString.
	"self printSpaceTally.
"	methodsToSwap := self compiledMethodsToSwap.
	
	CompiledMethodProxySwapperHandler serializer: FuelMareaSerializer. 
	self log: 'CompiledMethods to swap: ',  methodsToSwap size asString.
	
	counter := 0.
	[timeToInstall := MessageTally time: [
	methodsToSwap do: [:method| 
		(counter \\ 5000) isZero ifTrue: [
			self log: ''.
			"self log: SmalltalkImage current vmStatisticsReportString."
			self log: ''.
		]. 
		counter := counter + 1.
		self installOn: method methodClass selector: method selector.].
	].

	Smalltalk allClassesDo: [:aClass | aClass hasAllMethodsAsProxies ifTrue: [ClassProxySwapper installOn: aClass ]. ].

	self log: 'Time to install proxies: ', timeToInstall asString, ' miliseconds'.
	methodsToSwap := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Methods Proxies intalled: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances after installing: ', CompiledMethod instanceCount asString.
	self log: 'Class Proxies intalled: ',  ClassProxySwapper  mareaAllInstalledProxiesCount asString.
	self log: 'Class instances after installing: ', Smalltalk allClassesAndTraits size asString.
	
	self log: 'Memory used using proxies: ', (Smalltalk vmParameterAt: 3) asString.

"	timeToUninstall := MessageTally time: [
		counter := 0.
		self proxyClass mareaAllInstalledProxies do: [:instance| 
			(counter \\ 5000) isZero ifTrue: [
				self log: ''.
				self log: SmalltalkImage current vmStatisticsReportString.
				self log: ''.
				self printSpaceTally.
			]. 
		counter := counter + 1.
		instance mareaUninstallIfNeeded
		].		
	]."
	self log: 'Time to uninstall proxies: ', timeToUninstall asString, ' miliseconds'.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Method Proxies installed instances after uninstalling: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Class Proxies installed instances after uninstalling: ', ClassProxySwapper  mareaAllInstalledProxiesCount asString.
	self log: 'Memory used after uninstalling proxies: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'CompiledMethod instances after uninstalling: ', CompiledMethod instanceCount asString.
	self log: 'Class instances after uninstalling: ', Smalltalk allClassesAndTraits size asString.
	"self printSpaceTally."
	] ensure: [
		self log: 'Ensure....'.
		MareaLogger changeToFileLogger.
		"self proxyClass mareaUninstallIfNeededAllInstances."
"		(FileDirectory default fileNamesMatching: '*.swap*') 
			do: [ :aFile | FileDirectory default deleteFileNamed: aFile ]."
	]! !

!CompiledMethodSwapper class methodsFor: 'examples' stamp: 'MarianoMartinezPeck 7/6/2011 15:43'!
exampleSwapOutUnusedTestClasses
	"self exampleSwapOutUnusedTestClasses"
	| classesToSwap timeToInstall timeToUninstall |
	ClassProxySwapperHandler serializer: FuelCachedMareaSerializer newDefault. 
	self proxyClass: ClassProxySwapper.
	self proxyClass runningTest: false.
	"self proxyClass mareaResetNumber."
	Logger := nil.
	MareaLogger disableLogging.
	3 timesRepeat: [Smalltalk garbageCollect].
	Symbol compactSymbolTable.
	self log: 'Using proxy class: ', self proxyClass name.
	self log: 'Proxies installed instances before start: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Metaclass instances before start: ', Metaclass instanceCount asString.
	self log: 'Memory used before proxies: ', (Smalltalk vmParameterAt: 3) asString.
	classesToSwap := OrderedCollection new.
(PackageInfo allPackages select: [:each| each packageName includesSubString: 'Test'] ) do: [:aPackage |
		aPackage classes do: [:aClass | (UnusedObjectDiscoverer current primitiveGetUsedBit: aClass) 
			ifFalse: [classesToSwap add: aClass ]. 
			].
		].
	self log: 'Metaclasss to swap: ',  classesToSwap size asString.
	[
	timeToInstall := MessageTally time: [
	classesToSwap do: [:class| self installOn: class ].
	].
	self log: 'Time to install proxies: ', timeToInstall asString, ' miliseconds'.
	classesToSwap := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies intalled: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Metaclass instances after installing: ', Metaclass instanceCount asString.
	Symbol compactSymbolTable.
	self log: 'Memory used using proxies after compacting symbol table: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'Memory used using proxies: ', (Smalltalk vmParameterAt: 3) asString.
	timeToUninstall := MessageTally time: [self proxyClass mareaUninstallIfNeededAllInstances].
	self log: 'Time to uninstall proxies: ', timeToUninstall asString, ' miliseconds'.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies installed instances after uninstalling: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Memory used after uninstalling proxies: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'Metaclass instances after uninstalling: ', Metaclass instanceCount asString.
	] ensure: [
		self proxyClass mareaUninstallIfNeededAllInstances.
		(FileDirectory default fileNamesMatching: '*.swap*') 
			do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
	]! !

!CompiledMethodSwapper class methodsFor: 'examples' stamp: 'MarianoMartinezPeck 7/6/2011 15:02'!
exampleSwapOutUnusedTestMethods
	"self exampleSwapOutUnusedTestMethods"
	| classesToSwap timeToInstall timeToUninstall |
	CompiledMethodProxySwapperHandler serializer: FuelCachedMareaSerializer newDefault. 
	self proxyClass: ClassProxySwapper.
	self proxyClass runningTest: false.
	self proxyClass mareaResetNumber.
	Logger := nil.
	MareaLogger disableLogging.
	3 timesRepeat: [Smalltalk garbageCollect].
	Symbol compactSymbolTable.
	self log: 'Using proxy class: ', self proxyClass name.
	self log: 'Proxies installed instances before start: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances before start: ', CompiledMethod instanceCount asString.
	self log: 'Memory used before proxies: ', (Smalltalk vmParameterAt: 3) asString.
	classesToSwap := OrderedCollection new.
(PackageInfo allPackages select: [:each| each packageName includesSubString: 'Test'] ) do: [:aPackage |
		aPackage classes do: [:aClass |
			classesToSwap addAll: aClass unusedMethods
			].
		].
	self log: 'CompiledMethods to swap: ',  classesToSwap size asString.
	[
	timeToInstall := MessageTally time: [
	classesToSwap do: [:method| self installOn: method methodClass selector: method selector.].
	].
	self log: 'Time to install proxies: ', timeToInstall asString, ' miliseconds'.
	classesToSwap := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies intalled: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances after installing: ', CompiledMethod instanceCount asString.
	Symbol compactSymbolTable.
	self log: 'Memory used using proxies after compacting symbol table: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'Memory used using proxies: ', (Smalltalk vmParameterAt: 3) asString.
	timeToUninstall := MessageTally time: [self proxyClass mareaUninstallIfNeededAllInstances].
	self log: 'Time to uninstall proxies: ', timeToUninstall asString, ' miliseconds'.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies installed instances after uninstalling: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Memory used after uninstalling proxies: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'CompiledMethod instances after uninstalling: ', CompiledMethod instanceCount asString.
	] ensure: [
		self proxyClass mareaUninstallIfNeededAllInstances.
		(FileDirectory default fileNamesMatching: '*.swap*') 
			do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
	]! !

!CompiledMethodSwapper class methodsFor: 'stuff to exclude' stamp: 'MarianoMartinezPeck 5/3/2011 18:00'!
fixedMethodsNotToSwap
	^ self selectorsNotToSwap
		inject: OrderedCollection new
		into: [:allMethods :aSelector | 
			allMethods addAll: 
				(CompiledMethod allInstances select: [:aMethod | aMethod selector = aSelector] ); yourself 
		]! !

!CompiledMethodSwapper class methodsFor: 'install' stamp: 'MarianoMartinezPeck 7/6/2011 15:39'!
installOn: aClass 
	^ self proxyClass installOn: aClass! !

!CompiledMethodSwapper class methodsFor: 'install' stamp: 'MarianoMartinezPeck 11/21/2010 16:27'!
installOn: aClass selector:  aSelector.
	^ self proxyClass installOn: aClass selector: aSelector.! !

!CompiledMethodSwapper class methodsFor: 'lists' stamp: 'MarianoMartinezPeck 11/21/2010 18:32'!
listOfCorePackages
	^ self listOfCorePackagesNames collect: [:each |  PackageInfo named: each ]! !

!CompiledMethodSwapper class methodsFor: 'lists' stamp: 'MarianoMartinezPeck 11/21/2010 18:32'!
listOfCorePackagesNames
	"To recreate this list, you can take a PharoCore image and print:
	PackageInfo allPackages collect: [:each| each packageName] 
"

	^  #('MultilingualTests' 'Morphic' 'ToolBuilder-Kernel' 'PackageInfo' 'Polymorph-ToolBuilder' 'Network-Kernel' 'Network-Protocols' 'Compiler' 'System-Finalization' 'Settings-Graphics' 'Collections' 'Network-RemoteDirectory' 'Traits' 'Network-URI' 'Settings-Display' 'Collections-Abstract' 'Settings-Compiler' 'MonticelloMocks' 'ScriptLoader11' 'System-Digital Signatures' 'System-Localization' 'MenuRegistration' 'Polymorph-TaskbarIcons' 'Monticello' 'ToolBuilder-Morphic' 'MCDirtyPackage' 'Collections-Weak' 'Settings-Polymorph' 'Tests' 'HelpSystem-Core-Utilities' 'SUnit' 'Collections-Text' 'Compression' 'Morphic-MorphTreeWidget' 'HelpSystem-Core' 'ToolsTest' 'Gofer-Core' 'Gofer-Tests' 'Collections-Stack' 'FreeType' 'MonticelloConfigurations' 'Polymorph-Geometry' 'Collections-Support' 'SUnitGUI' 'HelpSystem-Core-Model' 'Tests-VM' 'System-Change Notification' 'System' 'Tests-ObjectsAsMethods' 'HostMenus' 'Network-MIME' 'Network-RFC822' 'VB-Regex' 'TrueType' 'DeprecatedPreferences' 'System-Clipboard' 'System-Settings' 'MorphicTests' 'System-Serial Port' 'NetworkTests' 'Collections-Unordered' 'System-Changes' 'System-Object Storage' 'Collections-Traits' 'System-Platforms' 'Tests-PrimCallController' 'Morphic-TrueType' 'Multilingual' 'Graphics' 'Collections-Strings' 'KernelTests' 'System-FileRegistry' 'Tests-Bugs' 'ToolBuilder-SUnit' 'Tests-Release' 'Morphic-Balloon' 'Settings-Network' 'System-Applications' 'Polymorph-Tools-Diff' 'Settings-Tools' 'ScriptLoader' 'ST80' 'FreeTypeSubPixelAntiAliasing' 'Settings-Kernel' 'Settings-System' 'CompilerTests' 'System-Tools' 'System-Hashing' 'System-Download' 'Collections-Streams' 'Tests-SystemChangeNotification' 'GraphicsTests' 'Polymorph-Widgets' 'Kernel' 'Tools' 'Settings-FreeType' 'FreeTypeTests' 'Settings-Monticello' 'HelpSystem-Tests' 'Polymorph-EventEnhancements' 'System-Support' 'MonticelloGUI' 'System-FilePackage' 'System-Object Events' 'Announcements' 'System-Text' 'Exceptions' 'Network-UUID' 'System-Pools' 'FixUnderscores' 'HelpSystem-Core-UI' 'GraphicsResources' 'Files' 'Gofer' 'Network-MailSending' 'Collections-Arrayed' 'CollectionsTests' 'Balloon' 'Network-Url' 'Collections-Sequenceable')! !

!CompiledMethodSwapper class methodsFor: 'lists' stamp: 'MarianoMartinezPeck 11/21/2010 18:32'!
listOfNotDangerousCorePackages
	^ self listOfNotDangerousCorePackagesNames collect: [:each |  PackageInfo named: each ]! !

!CompiledMethodSwapper class methodsFor: 'lists' stamp: 'MarianoMartinezPeck 11/22/2010 21:40'!
listOfNotDangerousCorePackagesNames
	"To recreate this list, you can take a PharoCore image and print:
	PackageInfo allPackages collect: [:each| each packageName] 
"

	^ #('Morphic' 'ToolBuilder-Kernel' 'PackageInfo' 'Polymorph-ToolBuilder' 'Network-Kernel' 'Network-Protocols' 'Compiler' 'System-Finalization' 'Settings-Graphics' 'Collections' 'Network-RemoteDirectory' 'Traits' 'Network-URI' 'Settings-Display' 'Collections-Abstract' 'Settings-Compiler' 'MonticelloMocks' 'ScriptLoader11' 'System-Digital Signatures' 'System-Localization' 'MenuRegistration' 'Polymorph-TaskbarIcons' 'Monticello' 'ToolBuilder-Morphic' 'MCDirtyPackage' 'Collections-Weak' 'Settings-Polymorph' 'HelpSystem-Core-Utilities' 'SUnit' 'Collections-Text' 'Compression' 'Morphic-MorphTreeWidget' 'HelpSystem-Core' 'Gofer-Core' 'Collections-Stack' 'FreeType' 'MonticelloConfigurations' 'Polymorph-Geometry' 'Collections-Support' 'SUnitGUI' 'HelpSystem-Core-Model' 'System-Change Notification' 'System' 'HostMenus' 'Network-MIME' 'Network-RFC822' 'VB-Regex' 'TrueType' 'DeprecatedPreferences' 'System-Clipboard' 'System-Settings' 'System-Serial Port' 'Collections-Unordered' 'System-Changes' 'System-Object Storage' 'Collections-Traits' 'System-Platforms' 'Morphic-TrueType' 'Multilingual' 'Graphics' 'Collections-Strings' 'System-FileRegistry' 'ToolBuilder-SUnit' 'Morphic-Balloon' 'Settings-Network' 'System-Applications' 'Polymorph-Tools-Diff' 'Settings-Tools' 'ScriptLoader' 'ST80' 'FreeTypeSubPixelAntiAliasing' 'Settings-Kernel' 'Settings-System' 'System-Tools' 'System-Hashing' 'System-Download' 'Collections-Streams' 'Polymorph-Widgets' 'Kernel' 'Tools' 'Settings-FreeType' 'Settings-Monticello' 'Polymorph-EventEnhancements' 'System-Support' 'MonticelloGUI' 'System-FilePackage' 'System-Object Events' 'Announcements' 'System-Text' 'Exceptions' 'Network-UUID' 'System-Pools' 'FixUnderscores' 'HelpSystem-Core-UI' 'GraphicsResources' 'Files' 'Gofer' 'Network-MailSending' 'Collections-Arrayed' 'Balloon' 'Network-Url' 'Collections-Sequenceable')! !

!CompiledMethodSwapper class methodsFor: 'logging' stamp: 'MarianoMartinezPeck 11/30/2010 13:27'!
log: aString
	self logger log: aString ! !

!CompiledMethodSwapper class methodsFor: 'logging' stamp: 'MarianoMartinezPeck 11/30/2010 13:32'!
logger	
	Logger isNil ifTrue: [
		Logger := FixesFileNameLoggerStrategy named: 'Swapper.txt'.
		Logger startLogging].
	^ Logger! !

!CompiledMethodSwapper class methodsFor: 'stuff to exclude' stamp: 'MarianoMartinezPeck 11/30/2010 18:09'!
methodsUsedByMareaTesting
	| suite |
	suite := TestSuite named: 'zaraza'. 
	AbstractCompiledMethodProxyTest withAllSubclasses do: [:each |
		TestCase addTestsFor: each name toSuite: suite.].
	suite tests: (suite tests reject: [:each | each testSelector = #testCompiledMethodProxyAndGC]). 
	suite run. 
 ! !

!CompiledMethodSwapper class methodsFor: 'stuff to exclude' stamp: 'MarianoMartinezPeck 5/13/2011 13:58'!
packagesNotToSwap.
	"Notice that this is the strict way. If there are errors difficult to debug I would uncomment the commented ones and try."
	^ (# ("'System-Object Storage'" 'Fuel' 'Kernel' "'Graphics'" 'Exceptions' 'Proxies' "'Settings' ""'System'" 'UsedObject' "'Traits'" "'Balloon'" 'Tools-Base' "'Morphic'" "'ToolBuilder'" 'Compiler' ) collect: [:aPackageName | PackageInfo named: aPackageName]),
	(PackageInfo allPackages select: [:each | each packageName includesSubString: 'Collections-' ])
	
! !

!CompiledMethodSwapper class methodsFor: 'logging' stamp: 'MarianoMartinezPeck 12/2/2010 16:04'!
printSpaceTally
	self log: ''.
	self log: ''.
	SpaceTally new printSpaceAnalysis: 1 on: self logger logFile maxResults: 10. 
	self log: ''.
	self log: ''.! !

!CompiledMethodSwapper class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/21/2010 16:24'!
proxyClass
	^ ProxyClass! !

!CompiledMethodSwapper class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/21/2010 16:25'!
proxyClass: aProxyClass
	ProxyClass := aProxyClass.! !

!CompiledMethodSwapper class methodsFor: 'stuff to exclude' stamp: 'MarianoMartinezPeck 5/3/2011 18:06'!
selectorsNotToSwap
	^ #(#class #DoIt), (Smalltalk specialObjectsArray select: [:each | each isSymbol])
	
! !

Object subclass: #GraphTraverser
	instanceVariableNames: 'stack traversedObjects serializedObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-GraphTraverse'!

GraphTraverser subclass: #GraphProxiesCreator
	instanceVariableNames: 'proxiesDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-GraphTraverse'!

!GraphProxiesCreator methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/13/2011 10:54'!
createProxyFor: anObject
	^ MareaProxyMock new.! !

!GraphProxiesCreator methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/27/2011 12:06'!
doInterception: anObject
	"We traverse the graph and, for each object, we create a proxy for it. They are added to an IdentityDictionary. Each key of the dict is an original object of the graph. The value associated with each key, is the proxy created for that object. If we find a proxy as part of the graph, we do not create a proxy for the proxy, but instead, we directly use the same proxy instance. Moreever, in this case, we need to add this shared proxy in a table which is non-weak in order to not loose shared proxies. 
	Notice that it is common to find proxies inside the graph to swap out. This happens with objects that are shared between graphs and some of thise graphs were already swapped out.
	Finally, there are objects that cannot be #becomed like SmallIntegers. Hence we must avoid them. "
	(anObject mareaIsProxy)
		ifTrue: [ 
			proxiesDict at: anObject put: anObject.
			ObjectGraphSwapper globalSharedProxiesTable at: anObject mareaProxyID ifAbsentPut: anObject.
			 ]
		ifFalse: [
			(self shouldCreateProxyFor: anObject)   
				ifTrue: [ proxiesDict at: anObject put: (self createProxyFor: anObject)]].
			! !

!GraphProxiesCreator methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/13/2011 10:53'!
initialize 
	super initialize.
	proxiesDict := IdentityDictionary new.! !

!GraphProxiesCreator methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/13/2011 11:00'!
proxiesDict
	^ proxiesDict ! !

!GraphProxiesCreator methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2011 12:13'!
shouldCreateProxyFor: anObject
	(anObject class = SmallInteger) ifTrue: [^ false].
	(Smalltalk specialObjectsArray identityIncludes: anObject) ifTrue: [^ false].
	(anObject == Smalltalk) ifTrue: [^ false].
	serializedObjects at: anObject ifAbsent: [ ^ false ].
	^ true
	 ! !

!GraphProxiesCreator methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/13/2011 11:06'!
traverse: anObject
	super traverse: anObject.
	^ proxiesDict! !

!GraphTraverser class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/13/2011 10:43'!
traverse: anObject
	^ self new traverse: anObject! !

!GraphTraverser class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/27/2011 15:36'!
traverse: anObject  serializedObjects:  objectsIndexes
	^ (self new initializeWith: objectsIndexes) traverse: anObject.
	! !

!GraphTraverser methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/13/2011 10:51'!
doInterception: anObject
	"By default do not do anything"! !

!GraphTraverser methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/13/2011 10:43'!
followReferences: anObject

	(1 to: anObject class instSize) do: [:index | stack push: (anObject instVarAt: index)].

	1 to: anObject basicSize do: [ :index |
		stack push: (anObject basicAt: index) ]

! !

!GraphTraverser methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/27/2011 15:37'!
initialize 
	traversedObjects := IdentitySet new.
	stack := FLSimpleStack new.! !

!GraphTraverser methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/27/2011 15:37'!
initializeWith: objectsIndexes
	self initialize.
	serializedObjects := objectsIndexes.
	! !

!GraphTraverser methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/27/2011 15:37'!
trace: anObject

	traversedObjects addIfNotPresent: anObject ifPresentDo: [ ^self ].
	self doInterception: anObject.
	self followReferences: anObject! !

!GraphTraverser methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/27/2011 15:37'!
traverse: anObject 

	stack push: anObject.

	[ stack isEmpty ] 
		whileFalse: [ self trace: stack pop ].
		
	^ traversedObjects
! !

Object subclass: #Interception
	instanceVariableNames: 'message receiver target proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Swapping'!

!Interception class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 13:53'!
for: aMessage target: aTargetObject proxy: aProxy receiver: aReceiver
	^ self new initializewith: aMessage 
		target: aTargetObject
		proxy: aProxy 
		receiver: aReceiver ! !

!Interception methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 13:39'!
initializewith: aMessage target: aTargetObject proxy: aProxy  receiver: aReceiver 
	message := aMessage.
	target := aTargetObject.
	proxy := aProxy.
	receiver := aReceiver.! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
message
	^ message! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
message: anObject
	message := anObject! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
proxy
	^ proxy! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
proxy: anObject
	proxy := anObject! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
receiver
	^ receiver! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
receiver: anObject
	receiver := anObject! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
target
	^ target! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
target: anObject
	target := anObject! !

Object subclass: #MareaProxyMock
	instanceVariableNames: 'proxyID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Swapping'!

!MareaProxyMock class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2011 14:50'!
newProxyFor: anObject 
	^ self new! !

!MareaProxyMock methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/16/2011 14:59'!
mareaGraphID
	^ proxyID bitAnd: 2r111111111111111! !

!MareaProxyMock methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/16/2011 10:46'!
mareaIsProxy
	^ true! !

!MareaProxyMock methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/16/2011 14:35'!
mareaPosition
	^ proxyID >> 15 
	! !

!MareaProxyMock methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/16/2011 14:38'!
mareaProxyID
	^ proxyID! !

!MareaProxyMock methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/16/2011 14:34'!
mareaSetPosition: aPosition setGraphID: aGraphID
	proxyID :=  (aGraphID bitAnd: 16rFFFF) bitOr: (aPosition << 15).
! !

Object subclass: #ObjectGraphSwapper
	instanceVariableNames: ''
	classVariableNames: 'GraphTable IDGenerator Logger ProxyCreator SharedProxiesTable'
	poolDictionaries: ''
	category: 'Marea-Swapping'!

!ObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/4/2011 15:02'!
globalGraphTable
	GraphTable isNil ifTrue: [GraphTable := IdentityDictionary new].
	^ GraphTable! !

!ObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/19/2011 16:17'!
globalSharedProxiesTable
	SharedProxiesTable isNil ifTrue: [SharedProxiesTable := Dictionary new].
	^ SharedProxiesTable! !

!ObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2011 14:46'!
newProxyFor: anObject
	^ ProxyCreator newProxyFor: anObject! !

!ObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/9/2011 11:27'!
nextGraphID
	IDGenerator isNil ifTrue: [IDGenerator := 0].
	IDGenerator := IDGenerator + 1.
	^ IDGenerator! !

!ObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2011 14:48'!
proxyCreator: aProxyCreator
	ProxyCreator := aProxyCreator ! !

!ObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/9/2011 14:44'!
resetGlobalTable
	GraphTable := nil.! !

!ObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/9/2011 14:45'!
resetGraphID
	IDGenerator := nil.! !

!ObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/19/2011 15:21'!
resetSharedProxiesTable
	SharedProxiesTable := nil.! !

!ObjectGraphSwapper methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 9/20/2011 11:30'!
becomeOriginalObjects: originalObjects toProxies: proxies

	"Finally, do a bulk become betwee the original objects and the proxies"
	originalObjects elementsForwardIdentityTo: proxies.
! !

!ObjectGraphSwapper methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 12/1/2011 19:26'!
createClassProxyFor: aClass
	^ ClassProxy  newProxyFor: aClass.! !

!ObjectGraphSwapper methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 9/29/2011 14:43'!
createProxyFor: anObject
	^ self class newProxyFor: anObject.! !

!ObjectGraphSwapper methodsFor: 'private' stamp: 'MarianoMartinezPeck 12/1/2011 12:02'!
fileNameFrom: graphID
	^ graphID asString, '.swap'! !

!ObjectGraphSwapper methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/9/2011 11:59'!
globalGraphTable
	^ self class globalGraphTable! !

!ObjectGraphSwapper methodsFor: 'swap in' stamp: 'MarianoMartinezPeck 9/27/2011 17:16'!
materializeFromFileNamed: graphIDString
	
	"We get the ID and we search a file named as the ID. Then we materialize it."	
	^ (FLMaterializer materializationFromFileNamed: graphIDString) materializedInstances.
	 ! !

!ObjectGraphSwapper methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 11/30/2011 11:44'!
nextAvailableID
	^ self class nextGraphID ! !

!ObjectGraphSwapper methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/13/2011 11:15'!
originalObjectsAbleToBecome: originalObjects! !

!ObjectGraphSwapper methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 12/1/2011 11:58'!
serialize: anObject toFileNamed: graphIDString
	
	"We serialize the graph and we answer the serialization object"
	^ FuelMareaSerializer newDefault serializeAndWriteObject: anObject to: graphIDString.! !

!ObjectGraphSwapper methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 12/1/2011 11:46'!
shouldCreateProxyFor: anObject
	(anObject class = SmallInteger) ifTrue: [^ false].
	(Smalltalk specialObjectsArray identityIncludes: anObject) ifTrue: [^ false].
	anObject isBehavior ifTrue: [^ false].
	(anObject == Smalltalk globals) ifTrue: [^ false].
	(FLGlobalMapper defaultGlobals identityIncludes: anObject) ifTrue: [^ false].
	(anObject isKindOf: Symbol) ifTrue: [^ false]. 
	^ true
	 ! !

!ObjectGraphSwapper methodsFor: 'swap in' stamp: 'MarianoMartinezPeck 12/1/2011 12:06'!
swapInGraphFor: aProxy
	"So....a proxy has received a message and hence it needs to be uninstalled: it has to read the file from disc, materialize back the original graph and to the become back between all the proxies of the graph and the just materialized objects "

	| graphID dict materializedInstances |
	
	"We get the ID and we search a file named as the ID. Then we materialize it."	
	graphID := aProxy mareaGraphID.
	materializedInstances := self materializeFromFileNamed: (self fileNameFrom: graphID).
	
	 "Now we need to become all the proxies of the graph to the new materialized objects"
	dict := ProxiesIdentityDictionary new.
	self updateProxiesOfGraph: graphID withMaterializedInstances: materializedInstances filling: dict.
	self updateMissingSharedProxiesFrom: materializedInstances filling: dict.	
	dict keys elementsForwardIdentityTo: dict values.	
	
	"Finally we clean the global table"
	self globalGraphTable removeKey: graphID.
	
	"Once everything was done sucessfully we remove the file"
	FileDirectory default deleteFileNamed: (self fileNameFrom: graphID).
	
	"We need to answer the original object which was becomed with aProxy. But since it was become, the instVar aProxy is the correct one."
	^ aProxy
	! !

!ObjectGraphSwapper methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 12/1/2011 16:04'!
swapOutClass: aClass
	| dict  graphID serialization |

	graphID := self nextAvailableID.
	serialization := self serialize: aClass toFileNamed: (self fileNameFrom: graphID).
	dict := self traverseGraphAndCreateProxiesForSerializedObjects: serialization objectsIndexes.
	dict at: aClass put: (self createClassProxyFor: aClass).
	dict at: aClass class put: (self createClassProxyFor: aClass class).
	self updateProxiesPositionAndGraphID: dict serializedInstances: serialization objectsIndexes graphID: graphID.
	self becomeOriginalObjects: dict keys toProxies: dict values.
	self updateGlobalGraphTableWith: dict values graphID: graphID.

	dict := nil.
	serialization := nil.
	
	"At this moment, having done the bulk become and set the dict to nil, there are several objects that can be garbage collected: ALL original objects of the graph, no matter whether they are inner or shared. And ALL proxies that were associated with inner objects. The only proxies that are reachable, hence not garbage collected, are the proxy for the root of the graph, and the proxies for facade objects. Of course, notice that the whole object memory graph can change, and for example, it may happen that nobody else point to the root (now proxy) of the graph or to facade objects. If that happens, then those proxies are garbage collected as well "
	
	! !

!ObjectGraphSwapper methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 12/1/2011 12:01'!
swapOutGraph: anObject
	| dict  graphID serialization |

	graphID := self nextAvailableID.
	serialization := self serialize: anObject toFileNamed: (self fileNameFrom: graphID).
	dict := self traverseGraphAndCreateProxiesForSerializedObjects: serialization objectsIndexes.
	self updateProxiesPositionAndGraphID: dict serializedInstances: serialization objectsIndexes graphID: graphID.
	self becomeOriginalObjects: dict keys toProxies: dict values.
	self updateGlobalGraphTableWith: dict values graphID: graphID.

	dict := nil.
	serialization := nil.
	
	"At this moment, having done the bulk become and set the dict to nil, there are several objects that can be garbage collected: ALL original objects of the graph, no matter whether they are inner or shared. And ALL proxies that were associated with inner objects. The only proxies that are reachable, hence not garbage collected, are the proxy for the root of the graph, and the proxies for facade objects. Of course, notice that the whole object memory graph can change, and for example, it may happen that nobody else point to the root (now proxy) of the graph or to facade objects. If that happens, then those proxies are garbage collected as well "
	
	! !

!ObjectGraphSwapper methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 10/4/2011 15:03'!
traverseGraphAndCreateProxiesForSerializedObjects:  objectsIndexes
	"We traverse the graph and, for each object, we create a proxy for it. Traversing the original object graph can be complicated because we need to take into account global objects like Smalltalk globals so that to avoid traversing almost all image. Fuel already deals with that problem, hence we can use the serialized instances by Fuel, that is, objectsIndexes. 
	They are added to an IdentityDictionary. Each key of the dict is an original object of the graph. The value associated with each key, is the proxy created for that object. If we find a proxy as part of the graph, we do not create a proxy for the proxy, but instead, we directly use the same proxy instance. Notice that it is common to find proxies inside the graph to swap out. This happens with objects that are shared between graphs and some of thise graphs were already swapped out.
	Notice that in this case we reusing the traversal of the serializer, and not  traversing the whole original graph. This has two problems:
	- The serializer also traverse objects outside the graph, for example, the classes of the objects we serialize. See #shouldCreateProxyFor: for more details.
	- The serializer does some optimization for certain classes, like Time, Date, etc, where it does NOT traverse all its instance variables, but instead it just serialize a number that represents it. Hence, we are not really traversing the whole graph. For this aspect, it is even better to do this instead of traversing the orignal graph. Becauese we have be creating a proxy that we will not be able to retrieve back the original object to which we should do the become, because the original object was not even serialized in the stream. "
	| proxiesDict |
	proxiesDict := ProxiesIdentityDictionary new.
	objectsIndexes keysDo: [:anObject | 
	"We traverse the graph and, for each object, we create a proxy for it. They are added to an IdentityDictionary. Each key of the dict is an original object of the graph. The value associated with each key, is the proxy created for that object. If we find a proxy as part of the graph, we do not create a proxy for the proxy, but instead, we directly use the same proxy instance. Moreever, in this case, we need to add this shared proxy in a table which is non-weak in order to not loose shared proxies. 
	Notice that it is common to find proxies inside the graph to swap out. This happens with objects that are shared between graphs and some of thise graphs were already swapped out.
	Finally, there are objects that cannot be #becomed like SmallIntegers. Hence we must avoid them. "
		(anObject mareaIsProxy)
			ifTrue: [ 
				proxiesDict at: anObject put: anObject.
				ObjectGraphSwapper globalSharedProxiesTable at: anObject mareaProxyID ifAbsentPut: [anObject].
				 ]
			ifFalse: [
				(self shouldCreateProxyFor: anObject)   
					ifTrue: [ proxiesDict at: anObject put: (self createProxyFor: anObject)]].	
			].
	
	^ proxiesDict! !

!ObjectGraphSwapper methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 9/20/2011 11:28'!
updateGlobalGraphTableWith: proxies graphID: graphID.
	
	"There is a global table that keeps an entry per swapped graph. It is important to know which proxies there are for a certain graph, because when a proxy receives a message and it needs to load back the graph, it needs to known all the rest of the proxies that need the become as well. Hence, we keep a weak list of the proxies of the graph "
	self globalGraphTable at: graphID put: (WeakArray withAll: proxies).
! !

!ObjectGraphSwapper methodsFor: 'swap in' stamp: 'MarianoMartinezPeck 9/20/2011 16:03'!
updateMissingSharedProxiesFrom: materializedInstances filling: dict.	
		
	"So far we have only updated the proxies which were in the proxies array of the graph. However, there can be still some proxies we need to update. We can have the following situation:
	- A graph AAA has a shared object BBB with graph CCC.
	- Graph AAA is swapped out and then CCC is swapped out. When CCC is serialized, it will serialize the proxy PB for BBB.
	- Graph AAA is swapped in.
	Now, when CCC is swapped in, in the proxies table, the reference which used to point to the proxy PB, now points to the real object B. However, we still need to update the reference from the graph C. So we need to iterate to the just materialized instances and see whether we have proxies that we need to update"
	materializedInstances do: [:each |
		each mareaIsProxy ifTrue: [
			self class globalSharedProxiesTable 
				at: each mareaProxyID
				ifPresent: [:sharedProxy |
					"We become the proxy with whatever is in the table: a proxy or the target object. If it is a proxy, we just update the reference so that we point to the same proxy. If it is not a proxy, it means that the original object was already becomed because the original graph of such obejct was swapped in. In this case, again, we become the proxy to that object."
					dict at: each put: sharedProxy.
					] ].
		].	
! !

!ObjectGraphSwapper methodsFor: 'swap in' stamp: 'MarianoMartinezPeck 9/20/2011 15:59'!
updateProxiesOfGraph: graphID withMaterializedInstances: materializedInstances filling: dict

	| proxiesOfGraph |

	proxiesOfGraph := self globalGraphTable at: graphID.
	proxiesOfGraph do: [:each | 
		"Since this collection is weak, if it is nil it means it was a proxy for an object (inner or shared) which was finally garbage collected. There is nothing to do in that case. The same happens if the object is not nil, but it is a regular object (not a proxy). In this case, it should be a regular object which has been become from a previous proxy. Again, nothing to be done here. It is only necessary to do something when the object is a proxy.
		In addition, we may have put a proxy which was shared with another graph. Hence it may happen that such proxy was already uninstalled."
		each mareaIsProxy ifTrue: [  
			self class globalSharedProxiesTable 
				at: each mareaProxyID
				ifPresent: [:sharedProxy |
					"sharedProxy can be a proxy or the real object in case it was already uninstalled."
					(sharedProxy mareaGraphID == graphID)
						ifTrue: ["If the target object of such proxy was serialized with current graph we are swapping in, then we become the proxy with the original object." 
							dict at: each put: (materializedInstances at: each mareaPosition)]
						ifFalse: [ "If the target object of such proxy was serialized with ANOTHER graph we are swapping in, then we become the proxy with whatever is in the table: a proxy or the target object. If it is a proxy, we just update the reference so that we point to the same proxy. If it is not a proxy, it means that the original object was already becomed because the original graph of such obejct was swapped in. In this case, again, we become the proxy to that object.."
							dict at: each put: sharedProxy].
					]
				ifAbsent: [ "It means it was a regular proxy which was not shared with other graphs. Hence, we become the proxy to the original object"
					dict at: each put: (materializedInstances at: each mareaPosition)].	
			].
		].
	! !

!ObjectGraphSwapper methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 9/20/2011 11:43'!
updateProxiesPositionAndGraphID: dict serializedInstances: serializedInstances graphID: graphID.
	
	"Now that the graph was serialized, I need to set to each proxy, its associated relative offset in the stream. This is necessary when we need to uninstall the proxy and the back the become. We need to know who to do the became with."
	dict keysAndValuesDo: [:originalObject :proxy |
		"If the proxy is already a proxy it means that in this graph to swap out, there are proxies. This means that there was a shared object with another graph and such graph has already been swapped out. So we should not update the information of that proxy because otherwise we wont be able to get back the original object"
		originalObject mareaIsProxy ifFalse: [
			"It may happen that one of the original objects of the graph is not in the list of serialized objects. This is because usually, serializers like Fuel do some optimizations for certain classes and instead of traversing all its instances, they just serialize something smaller and different, like a number. An example, is the class Date. The instance variables 'start duration' are not traversed. Instead, Fuel serializes just a number that represents the Date. So, in this case, we will create a proxy for an object that it is not serialized. This is a problem and I don't really know how to solve to far. Luckily, it is not a very common case.' "
			proxy mareaSetPosition: (serializedInstances at: originalObject ifAbsent: [0]) setGraphID: graphID.].
	].

! !
